-- O
local setting
local outputDir, imageDir, isTrim, compressLevel
for line in io.lines("arguments.txt") do
    -- ݒ̓ǂݍ
    if setting == nil then
        setting = {}
        for key, value in string.gmatch(line, "([^\x09=]+)=([^\x09]*)") do
            setting[key] = value
        end
        -- ݒ̎擾
        outputDir = setting["outputDir"]
        imageDir = setting["imageDir"]
        isTrim = setting["isTrim"]
        compressLevel = setting["compressLevel"]
    end
end
-- ݒt@C폜
local success, args = pcall(os.remove("arguments.txt"))

-- ̕
local split = function (str, delim)
    local result = {}
    local pattern = "[^" .. delim .. "]+"
    for part in string.gmatch(str, pattern) do
        table.insert(result, part)
    end
    return result
end

-- 摜
local list = getFileList(imageDir, "*+PNAP+layers.txt", 1)
local len = string.len(imageDir) + 1
for i, path in pairs(list) do
    local subDir = string.gsub(getParentFolderName(string.sub(path, len)), "/", "\\")
    subDir = (subDir == "") and "\\" or subDir
    local fileName = ""
    local canvasWidth, canvasHeight = 0, 0
    local imageNum = 1
    local progressHeight = 0
    local count = 0
    -- ݒeLXg̏
    for line in io.lines(path) do
        local pieces = split(line, " \t")
        -- 摜TCYݒ肷(1s)
        if canvasWidth == 0 then
            canvasWidth = tonumber(pieces[1])
            canvasHeight = tonumber(pieces[2])
        -- 摜̓ǍƍAo(2sڈȍ~)
        else
            if fileName == "" then
                fileName = string.match(pieces[6], "^[^+]+")
            end
            local pasteX, pasteY = tonumber(pieces[2]), tonumber(pieces[3])
            loadImage(0, imageDir .. subDir .. pieces[6])
            local currentHeight = getHeightImage(0)
            createImage(imageNum, canvasWidth, canvasHeight, 0x000000ff)
            blendImage(imageNum, 0, 1, pasteX, pasteY)
            -- g̉摜ƕ\摜̍Əo
            if progressHeight ~= 0 and currentHeight > progressHeight * 2 then
                for num = 1, imageNum - 1 do
                    copyImage(0, imageNum)
                    blendImage(0, num, 1, 0, 0)
                    if isTrim == "1" then
                        trimmingImage(0, "UDLR")
                    end
                    local outputFileName = outputDir .. subDir .. fileName .. "_" .. count .. "_" .. (num - 1) .. ".png"
                    saveImage(0, outputFileName, 1, 0, tonumber(compressLevel), 0)
                    print("output: " .. outputFileName .. "\n")
                end
                count = count + 1
            -- \摜̓Ǎ̂
            else
                progressHeight = currentHeight
                imageNum = imageNum + 1
            end
        end
    end
    -- 摜̉
    for num = 0, imageNum do
        freeImage(num)
    end
end
